-- Jump Thok ability, version 2.3
-- Created by Wolfy with lots of assistance from Sryder13
-- Original Riders coding by Chaos Zero 64

-- To switch the script's selected skin, edit the restriction in the AbilitySpecial hook below as well as the MobjThinker if you uncommented it.

addHook("AbilitySpecial", function(player) -- This new hook takes care of literally everything!
	if (player.mo.skin == "sonic")
	and not (player.pflags & PF_THOKKED) then
		if (player.mo.eflags & MFE_UNDERWATER) then
			player.actionspd = $1 >> 1 -- Half speed while underwater
		else player.actionspd = skins[player.mo.skin].actionspd
		end
		if (player.actionspd > player.normalspeed) then -- Speed cap. Remove if using custom actionspd.
			player.actionspd = player.normalspeed 
		end
		local thoksound = true -- Makes the thoksound play, obviously. Set this to false if you'd rather not have it.
		--player.actionspd = $1 / 3; -- (BALANCE) TD leftover. Makes the JumpThok execute slower, so the thrust is less instant.
		
		player.pflags = $1 & ~PF_JUMPED
		P_DoJump(player, false)
		P_InstaThrust(player.mo, player.mo.angle, FixedMul(player.actionspd, player.mo.scale)); -- ZOOM
		P_SpawnThokMobj(player) -- Spawn the thok mobjs
		
		if (player.mo.info.attacksound and not player.spectator and thoksound) then -- If thoksound argument is true
			S_StartSound(player.mo, player.mo.info.attacksound) -- Play the THOK sound
		end
		
		player.pflags = $1 & ~PF_SPINNING; -- Not spinning or revving anymore
		player.pflags = $1 & ~PF_STARTDASH
		player.pflags = $1|PF_THOKKED -- They thokked!
		if (maptol & TOL_2D) then -- If in 2D/SRB1 then, slow momentum down, make it more controllable
			player.mo.momx = $1/2 
			player.mo.momy = $1/2 
		end
	end
end)

-- Riders' fall frame code, uncomment the MobjThinker to use it.
--[[
addHook("MobjThinker", function(mobj)
	local player = mobj.player
	if (player.mo and player.mo.skin == "sonic") then
		if (player.mo.momz < 0)
		and (player.pflags & PF_THOKKED)
		and not (player.mo.state >= S_PLAY_FALL1 and player.mo.state <= S_PLAY_FALL2) then
			player.pflags = $1 & ~PF_JUMPED
			player.mo.state = S_PLAY_FALL1
		end
	end
end, MT_PLAYER)]]